﻿Imports System.Reflection
Imports System.Windows.Markup

Namespace MyWpfExtensions
    <MarkupExtensionReturnType(GetType(Object))>
    Public Class MultiplyTypesaveExtension
        Inherits MarkupExtension


        Public Sub New()
        End Sub

        Public Sub New(value1 As Double, value2 As Double)
            Me.Value1 = value1 : Me.Value2 = value2
        End Sub

        <ConstructorArgument("value1")>
        Public Property Value1 As Double
        <ConstructorArgument("value2")>
        Public Property Value2 As Double


        Public Overrides Function ProvideValue(serviceProvider As IServiceProvider) As Object
            If serviceProvider Is Nothing Then Return Nothing
            Dim valueTarget = DirectCast(serviceProvider.GetService(GetType(IProvideValueTarget)), IProvideValueTarget)

            Dim calcResult = Value1 * Value2

            If valueTarget.TargetProperty.GetType Is GetType(DependencyProperty) Then
                Dim dp = DirectCast(valueTarget.TargetProperty, DependencyProperty)
                Return Convert.ChangeType(calcResult, dp.PropertyType)
            Else
                Dim info = DirectCast(valueTarget.TargetProperty, PropertyInfo)
                Return Convert.ChangeType(calcResult, info.PropertyType)
            End If

        End Function
    End Class
End Namespace
